;==============================================================================
; File: ADC12C.S
; Func: HC12compact Driver Routines for for TLC2543 11ch 12bit ADC
; Copr: (C)1998 by MCT, Oliver Thamm
; Vers: 1.1
;==============================================================================

	.include "hc12.i"

; SPICOD0 = PH4 = 0  > selects
; SPICOD1 = PH5 = 1  > the ADC


			.area text

;------------------------------------------------------------------------------
; void initADC(void);
;
_initADC::	rts					; nothing to do!


;------------------------------------------------------------------------------
; int getADC(int channel);
;
; Func: Get ADC result
; Args: A=Channel ($00..$0A) or Special channel ($0B..$0E)
;		Special channels:
;		$0B: VREF/2 ($800)	$0C: VREF-  ($000)
;		$0D: VREF+  ($FFF)	$0E: enter power save mode
; Retn: D=Value (12 Bit significant)
;
_getADC::	movb #$50,SP0CR1	; SPE+MSTR+/CPOL+/CPHA
			;
			; Initiate Conversion
			;
			bclr PORTH,$10		; SPICOD0 = L (enable SPICS2)
			lslb
			lslb				; move channel number to
			lslb				; upper 4 bits of control word
			lslb
			orab #$0c			; lower nibble: DL=16bits,MSB 1st,Unipolar
			pshb				; save control word
			jsr  _xferSPI		; send control word
			jsr  _xferSPI		; send anything as bits 8..15 (ignored by ADC)
			bset PORTH,$30		; SPICOD0/1 = H (deselect all SPI slaves)
			;
			; Wait until end of conversion
			; You may want to modify this in order to use interrupt
			; control (signal path: EOC->BR10->PT1)
			;
			bsr  __wtConvDone
			;
			; Get conversion result
			;
			bclr PORTH,$10		; SPICOD0 = L (enable SPICS2)
			pulb				; restore control word
			jsr  _xferSPI		; get data (high byte)
			pshb				; save high byte
			jsr  _xferSPI		; get data (low byte)
			pula				; restore high byte
			lsrd
			lsrd				; move result 4 bits to the right
			lsrd
			lsrd
			bset PORTH,$30		; SPICOD0/1 = H (deselect all SPI slaves)
			rts


__wtConvDone:
			ldaa #100		; wait for conversion result
__gadcwt:	deca			; 4 cyc x 125 ns x 100 = 50s (>10s)
			bne  __gadcwt
			rts

;==============================================================================
