;==============================================================================
; File: DAC12C.S
; Func: HC12compact Driver Routines for LTC1454 2ch 12bit DAC
; Copr: (C)1998 by MCT, Oliver Thamm
; Vers: 1.1
;==============================================================================

	.include "hc12.i"

; SPICOD0 = PH4 = 1  > selects
; SPICOD1 = PH5 = 0  > the DAC


	.area text

;------------------------------------------------------------------------------
; void initDAC(void);
;
_initDAC::	rts					; nothing to do!


;------------------------------------------------------------------------------
; void setDAC(int ch1, int ch2);
;
; Func: Update both DAC channels
;
_setDAC::	pshd				; ch1 -> 0,sp; ch2 -> 4,sp
			movb #$50,SP0CR1	; SPE+MSTR+/CPOL+/CPHA
			bclr PORTH,$20		; SPICOD1 = L (enable SPICS1)
			ldd  0,sp
			lsrd
			lsrd
			lsrd
			lsrd
			jsr  _xferSPI		; send DACA highest 8 Bit
			ldaa 1,sp
			ldab 4,sp
			lslb
			lslb
			lslb
			lslb
			lsrd
			lsrd
			lsrd
			lsrd
			jsr  _xferSPI		; send DACA lowest 4 Bit, DACB highest 4 Bit
			ldab 5,sp
			jsr  _xferSPI		; send DACB lowest 8 Bit
			bset PORTH,$30		; SPICOD0/1 = H (disable SPI slaves)
			puld				; releasing /CS will latch the new DAC output!
			rts


;==============================================================================
