//=============================================================================
// File: HC12CO.H
// Func: C-Header File containing definitions specific for HC12compact
// Vers: 1.1
// Copr: (C)1998 by MCT, Oliver Thamm
//=============================================================================

#ifndef __HC12CO_H
#define __HC12CO_H	1

#include <hc12.h>


//-----------------------------------------------------------------------------
// Module: SPI12C.S
//-----------------------------------------------------------------------------

void initSPI(void);
int  xferSPI(int abyte);


//-----------------------------------------------------------------------------
// Module: ADC12C.S
//-----------------------------------------------------------------------------

void initADC(void);
int  getADC(int channel);


//-----------------------------------------------------------------------------
// Module: DAC12C.S
//-----------------------------------------------------------------------------

void initDAC(void);
void setDAC(int ch1, int ch2);


//-----------------------------------------------------------------------------
// Module: RTC12C.S
//-----------------------------------------------------------------------------

// low level RTC register access functions:
//
void initRTC(void);
unsigned  getRTC(unsigned aregno);	// aregno = 0x00..0x0f; retval: see abyte
void putRTC(unsigned abyte);		// abyte = (newval << 4) + aregno;

// access to battery backed RTC RAM (organized as 15 Bytes):
// Rem.: peekRTC(0x0f)==0x23 (this may be used for RTC identification)
//
unsigned peekRTC(unsigned addr);	// addr = 0..14
void pokeRTC(unsigned addr, unsigned newval);

// time+date access functions and structures:
//
struct timedate {			// all components are 2-digit BCD
	unsigned char second;
	unsigned char minute;
	unsigned char hour;
	unsigned char day;
	unsigned char month;
	unsigned char year;
	};
	
void getTimeDate(struct timedate *abuffer);
void setTimeDate(struct timedate *abuffer);


//-----------------------------------------------------------------------------
// Module: ALCD12C.S
//-----------------------------------------------------------------------------

void initLCD(int columns, int lines);
void clearLCD(void);
void putLCD(char c);
void gotoxyLCD(int x, int y);


//-----------------------------------------------------------------------------
// Module: SND12C.S
//-----------------------------------------------------------------------------

void initSND(void);
void isrOC2(void);
#define nosound() sound(0)
void sound(unsigned frequency);


//-----------------------------------------------------------------------------
// Misc
//-----------------------------------------------------------------------------

#define LED_OFF()    (PORTE |= 0x80)
#define LED_ON()     (PORTE &= ~0x80)
#define LED_TOGGLE() (PORTE ^= 0x80)


#endif
