;==============================================================================
; File: SND12C.S
; Func: HC12compact sounds good :-)
; Copr: (C)1998 by MCT, Oliver Thamm
; Vers: 1.0
;==============================================================================

			.include "hc12.i"

;------------------------------------------------------------------------------
			.area bss

_BuzzPeriod::
			.blkw 1


			.area text	

;------------------------------------------------------------------------------
; void initSND(void);
;
_initSND::	movb  #$32,TMSK2			; TimerPrescaler=4 (tick=0.5s)
			movb  #$80,TSCR				; enable Timer System
			bset  TIOS,$04				; PT2 is Output Compare
			bclr  TCTL2,$30				; Timer disconnected from Pin
			bset  TMSK1,$04				; C2I enable
			rts


;------------------------------------------------------------------------------
; void sound(unsigned frequency);
;
_sound::	cpd   #0
			bne   __sound2
__nosound:	bclr  TCTL2,$30				; Timer disconnected from PT2 Pin
			rts

__sound2:	pshd
			pshx
			ldx   2,sp					; freq
			ldd   #62500				; 1,000,000 / 16
			idiv						; x = d/x, remainder -> d
			xgdx
			lsld
			lsld
			lsld						; result x 16
			lsld
			xgdx
			stx   _BuzzPeriod
			ldx   2,sp					; freq
			lsld
			lsld
			lsld						; remainder x 16
			lsld
			idiv
			tfr   x,d
			orab  _BuzzPeriod+1
			stab  _BuzzPeriod+1			; fill in 4 least significant bits
			bset  TCTL2,$10				; OC2 action: toggle PT2 Pin
			pulx
			puld
			rts


;------------------------------------------------------------------------------
; Rem.: DO NOT FORGET to set up the TC2 interrupt vector at $ffea (1)
;       or the pseudo vector/jmp in RAM at $0be2 (2)!
;		Use INTR_ON(); to globally enable interrupts!
;
; Example (1):
;		extern void isrOC2(void);
;		#pragma abs_address:0xffea
;		void (*oc2intvec)(void) = isrOC2;
;		#pragma end_abs_address
;
; Example (2):
;		extern void isrOC2(void);
;       *((unsigned char *)0x0be2) = 0x06;	// JMP opcode
;       *((void (**)(void))0x0be3) = isrOC2;
;------------------------------------------------------------------------------
; void isrOC2(void);
;
_isrOC2::	movb  #$04,TFLG1			; clear OC2 Int Flag
			ldd   TC2
			addd  _BuzzPeriod
			std   TC2
			rti


;==============================================================================
