;==============================================================================
; File: SPI12C.S
; Func: HC12compact SPI Routines
; Copr: (C)1998 by MCT, Oliver Thamm
; Vers: 1.0
;==============================================================================

	.include "hc12.i"

; SPI Slave Chip Select Decoder:
;
; SPICOD0 SPICOD1
;   PH4     PH5
; ------------------------------
;    0       0     SPICS0    RTC
;    1       0     SPICS1    DAC
;    0       1     SPICS2    ADC
;    1       1     none selected


	.area text

; void initSPI(void);
;
_initSPI::	bset PORTH,$30		; SPICOD0/1 (PH4,5) = H
			bset DDRH,$30		; PH4,5 Output
			bset DDRS,$e0		; /SS,SCK,MOSI Output
			movb #$03,SP0BR		; SPI Rate = ECLK/16 (500kHz)
			movb #$54,SP0CR1	; SPE+MSTR+/CPOL+CPHA
			movb #$08,SP0CR2	; as default
			rts


; int xferSPI(int abyte);
;
_xferSPI::	stab SP0DR
__xfs1:		tst  SP0SR
			bpl  __xfs1
			clra
			ldab SP0DR
			rts


;==============================================================================
